{------------------------------------------------------------------------------}
{                                                                              }
{  Actor Editor for Office Assistant Package                                   }
{  by Kambiz R. Khojasteh                                                      }
{                                                                              }
{  kambiz@delphiarea.com                                                       }
{  http://www.delphiarea.com                                                   }
{                                                                              }
{  Special thanks to:                                                          }
{    Kim Bracknell <kbracknell@foi.wa.gov.au>                                  }
{                                                                              }
{------------------------------------------------------------------------------}

unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, StdActns, ActnList, Menus, ImgList, ComCtrls, ToolWin, ExtCtrls,
  RxSpin, CheckLst, Placemnt, MRUList, ExtDlgs, AppEvnts, StrHlder, TimerLst,
  Relation;

type
  TActorEditor = class(TForm)
    ActionList: TActionList;
    AnimationNew: TAction;
    AnimationNewFrame: TAction;
    EditCut: TEditCut;
    AnimationNewFrameFromImages: TAction;
    EditCopy: TEditCopy;
    AnimationPlay: TAction;
    AnimationPreviewBranch: TAction;
    EditPaste: TEditPaste;
    FileNew: TAction;
    FileOpen: TAction;
    FileSave: TAction;
    FileSaveAs: TAction;
    EditDelete: TAction;
    FileBuild: TAction;
    FileExit: TAction;
    HelpAbout: TAction;
    AnimationLoadImage: TAction;
    AnimationSaveImage: TAction;
    AnimationLoadSound: TAction;
    AnimationSaveSound: TAction;
    AnimationRemoveSound: TAction;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Animation1: TMenuItem;
    Help1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    SaveAs1: TMenuItem;
    N1: TMenuItem;
    BuildActor1: TMenuItem;
    N2: TMenuItem;
    Exit1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    About1: TMenuItem;
    NewAnimation1: TMenuItem;
    NewFrame1: TMenuItem;
    NewFramefromImages1: TMenuItem;
    N3: TMenuItem;
    Importimage1: TMenuItem;
    Exportimage1: TMenuItem;
    N4: TMenuItem;
    Importsoundeffect1: TMenuItem;
    Exportsoundeffect1: TMenuItem;
    Removesoundeffect1: TMenuItem;
    N5: TMenuItem;
    Preview1: TMenuItem;
    PreviewExitBranching1: TMenuItem;
    AnimationStop: TAction;
    Toolbar: TToolBar;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    ToolButton21: TToolButton;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    StatusBar: TStatusBar;
    TreeView: TTreeView;
    DetailsPanel: TPanel;
    Notebook: TNotebook;
    ActorName: TEdit;
    Label1: TLabel;
    DefFrameGroupBox: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    AnimWidth: TRxSpinEdit;
    AnimHeight: TRxSpinEdit;
    Label2: TLabel;
    DefaultDuration: TRxSpinEdit;
    Label3: TLabel;
    PaletteGroupBox: TGroupBox;
    LoadPalette: TButton;
    Label4: TLabel;
    Transparent: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label7: TLabel;
    ReturnAnimation: TComboBox;
    AnimationName: TEdit;
    AnimationActions: TCheckListBox;
    BranchGroupBox: TGroupBox;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Bevel2: TBevel;
    F1: TRxSpinEdit;
    P1: TRxSpinEdit;
    F2: TRxSpinEdit;
    P2: TRxSpinEdit;
    F3: TRxSpinEdit;
    P3: TRxSpinEdit;
    F4: TRxSpinEdit;
    P4: TRxSpinEdit;
    PRest: TEdit;
    ExitBranched: TCheckBox;
    ExitFrame: TRxSpinEdit;
    DurationGroupBox: TGroupBox;
    Label17: TLabel;
    Duration: TRxSpinEdit;
    ActionAnimations: TCheckListBox;
    Label8: TLabel;
    Label11: TLabel;
    Language: TComboBox;
    VersionGroupBox: TGroupBox;
    Label19: TLabel;
    VerInfo: TComboBox;
    VerValue: TMemo;
    Label18: TLabel;
    FormStorage: TFormStorage;
    MRUManager: TMRUManager;
    Reopen: TMenuItem;
    N6: TMenuItem;
    FramePopupMenu: TPopupMenu;
    NewFrame2: TMenuItem;
    NewFramefromImages3: TMenuItem;
    MenuItem1: TMenuItem;
    Loadframeimage1: TMenuItem;
    Saveframeimage1: TMenuItem;
    MenuItem2: TMenuItem;
    Loadsoundeffect1: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem13: TMenuItem;
    MenuItem14: TMenuItem;
    MenuItem15: TMenuItem;
    MenuItem16: TMenuItem;
    AnimationPopupMenu: TPopupMenu;
    MenuItem9: TMenuItem;
    NewFrame3: TMenuItem;
    NewFramefromImages2: TMenuItem;
    N9: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    Play2: TMenuItem;
    PreviewExitBranching2: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDialog: TOpenDialog;
    ApplicationEvents: TApplicationEvents;
    SaveDialog: TSaveDialog;
    SavePictureDialog: TSavePictureDialog;
    AnimationPreview: TAction;
    OpenSoundDialog: TOpenDialog;
    SaveSoundDialog: TSaveDialog;
    BuildDialog: TSaveDialog;
    LibSource: TStrHolder;
    RxTimerList: TRxTimerList;
    NextFrame: TRxTimerEvent;
    OptimizePalette: TButton;
    ChangeTransparent: TButton;
    ImageList: TImageList;
    DCC32: TLabel;
    Splitter: TSplitter;
    procedure WMDropFiles(var Msg: TMessage); message WM_DROPFILES;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormDestroy(Sender: TObject);
    procedure ApplicationEventsHint(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure MRUManagerClick(Sender: TObject; const RecentName,
      Caption: String; UserData: Integer);
    procedure StatusBarResize(Sender: TObject);
    procedure TreeViewChange(Sender: TObject; Node: TTreeNode);
    procedure TreeViewMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TreeViewDblClick(Sender: TObject);
    procedure TreeViewStartDrag(Sender: TObject;
      var DragObject: TDragObject);
    procedure TreeViewDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeViewDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure NextFrameTimer(Sender: TObject);
    procedure ActorNameChange(Sender: TObject);
    procedure ActorNameExit(Sender: TObject);
    procedure ActorNameKeyPress(Sender: TObject; var Key: Char);
    procedure LanguageChange(Sender: TObject);
    procedure VerInfoChange(Sender: TObject);
    procedure VerValueChange(Sender: TObject);
    procedure AnimWidthChange(Sender: TObject);
    procedure AnimHeightChange(Sender: TObject);
    procedure LoadPaletteClick(Sender: TObject);
    procedure OptimizePaletteClick(Sender: TObject);
    procedure ChangeTransparentClick(Sender: TObject);
    procedure AnimationNameExit(Sender: TObject);
    procedure ReturnAnimationChange(Sender: TObject);
    procedure AnimationActionsClickCheck(Sender: TObject);
    procedure DurationChange(Sender: TObject);
    procedure PrecentChange(Sender: TObject);
    procedure FrameBranchChange(Sender: TObject);
    procedure ExitBranchedClick(Sender: TObject);
    procedure ExitFrameChange(Sender: TObject);
    procedure ActionAnimationsClickCheck(Sender: TObject);
    procedure ActionListUpdate(Action: TBasicAction; var Handled: Boolean);
    procedure ActionListExecute(Action: TBasicAction; var Handled: Boolean);
    procedure FileNewExecute(Sender: TObject);
    procedure FileOpenExecute(Sender: TObject);
    procedure FileSaveExecute(Sender: TObject);
    procedure FileSaveAsExecute(Sender: TObject);
    procedure FileBuildExecute(Sender: TObject);
    procedure FileExitExecute(Sender: TObject);
    procedure EditCutExecute(Sender: TObject);
    procedure EditCopyExecute(Sender: TObject);
    procedure EditPasteExecute(Sender: TObject);
    procedure EditDeleteExecute(Sender: TObject);
    procedure AnimationNewExecute(Sender: TObject);
    procedure AnimationNewFrameExecute(Sender: TObject);
    procedure AnimationNewFrameFromImagesExecute(Sender: TObject);
    procedure AnimationPlayExecute(Sender: TObject);
    procedure AnimationPreviewBranchExecute(Sender: TObject);
    procedure AnimationStopExecute(Sender: TObject);
    procedure AnimationLoadImageExecute(Sender: TObject);
    procedure AnimationSaveImageExecute(Sender: TObject);
    procedure AnimationLoadSoundExecute(Sender: TObject);
    procedure AnimationSaveSoundExecute(Sender: TObject);
    procedure AnimationRemoveSoundExecute(Sender: TObject);
    procedure HelpAboutExecute(Sender: TObject);
    procedure SplitterCanResize(Sender: TObject; var NewSize: Integer;
      var Accept: Boolean);
  private
    Actor: TActorData;
    AnmIdx: Integer;
    FrmIdx: Integer;
    ActIdx: Integer;
    Modified: Boolean;
    Playing: Boolean;
    InternalChanging: Boolean;
    FileName: String;
    NoName: Boolean;
    Bitmap: TBitmap;
    AuxBitmap: TBitmap;
    ClickedItem: TTreeNode;
    PlayingExitBranching: Boolean;
    AnimationsNode: TTreeNode;
    function StatusText: String;
    procedure ResetControls;
    procedure EnableControls(Yes: Boolean);
    procedure ValidateActor;
    procedure BuildActor(LibName: String);
    procedure LoadFromFile(const aFileName: String);
    procedure SaveToFile(const aFileName: String; Temporary: Boolean = False);
    function IsSaved: Boolean;
    procedure ActorPaletteChanged;
    procedure ScaleImageToBitmap(G: TGraphic);
    procedure NewActor(DefaultAnimations: Boolean);
    procedure ApplyActor;
    procedure ApplyAnimation(Index: Integer);
    procedure ApplyFrame(AIndex, FIndex: Integer);
    procedure ApplyAction(Index: Integer; Recreate: Boolean);
    procedure AddAnimation(Animation: TAnimationData);
    procedure AddFrame(Frame: TFrameData);
    procedure LoadImage(ImageFileName: String; NewFrame: Boolean);
    procedure PlayAnimation(UseExitBranch: Boolean);
    procedure StopAnimation;
  end;

var
  ActorEditor: TActorEditor;

implementation

{$R *.DFM}

uses
  ShellAPI, MMSystem, Registry, StrUtils, Clipbrd, oaTypes, oaBitmap,
  Preview, Palette, About, RxGIF, PaletteLibrary;

resourcestring
  SFileModified     = '%s has been changed, Save changes to %s?';
  SMultiFrameFile   = '%s contains multiple frames.'#10#13#10#13 +
                      'Would you like to import all frames?';
  SDCC32Error       = 'Cannot locate Borland Delphi 32 command line compiler (DCC32.EXE)';
  SBuildError       = 'Actor Editor cannot build the library.'#10#13#10#13 +
                      'This error may occured becuase of:'#10#13 +
                      '   - the target drive is write protected.'#10#13 +
                      '   - the library is used by another program or marked as read-only.'#10#13 +
                      '   - the library file name contains space or illigal characters.';
  SInvalidLib       = '%s is not a valid actor library';
  SColorError       = 'The selected file %s is not a 256 color bitmap';
  SActorNameError   = 'Actor''s name must be a valid identifier name';
  SAnimNameError    = 'Enter a valid animation name';
  SAnimNameDupError = 'The animation name "%s" is already in use';
  SExitBranchError  = 'Frame %d does not have a valid exit path';
  SNoActorName      = 'Actor name is not specified';
  SNoFrame          = '%s has not any frame';
  SNoExitBranch     = '%s uses exit branching but does not have a frame with an exit branch';
  SNoRestPose       = 'The actor must at least have an animation assigned to RestPose action';
  SBadExitBranch    = 'Frame %d of %s does not have a valid exit path';

function TempFileName(Prefix: String): String;
var
  Buffer: array[0..255] of Char;
begin
  GetTempPath(SizeOf(Buffer), Buffer);
  GetTempFileName(Buffer, PChar(Prefix), 0, Buffer);
  Result := StrPas(Buffer);
end;

procedure TActorEditor.WMDropFiles(var Msg: TMessage);
var
  TheFile: array[0..255] of Char;
begin
  DragQueryFile(THandle(Msg.WParam), 0, TheFile, SizeOf(TheFile));
  DragFinish(THandle(Msg.WParam));
  LoadFromFile(StrPas(TheFile));
end;

function TActorEditor.StatusText: String;
var
  I, Count: Integer;
begin
  if Playing then
    if PlayingExitBranching then
      Result := Format('Playing exit branching %s', [Actor.Animations[AnmIdx].Name])
    else
      Result := Format('Playing %s', [Actor.Animations[AnmIdx].Name])
  else if FrmIdx >= 0 then
    with Actor.Animations[AnmIdx] do
      if Frames[FrmIdx].Sound.Size > 0 then
        Result := Format('%s, Frame %d, Has Sound', [Name, FrmIdx+1])
      else
        Result := Format('%s, Frame %d', [Name, FrmIdx+1])
  else if AnmIdx >= 0 then
    with Actor.Animations[AnmIdx] do
      if Frames.Count > 1 then
        Result := Format('%s, %d Frames', [Name, Frames.Count])
      else
        Result := Format('%s, %d Frame', [Name, Frames.Count])
  else if ActIdx >= 0 then
  begin
    Count := 0;
    for I := 0 to ActionAnimations.Items.Count-1 do
      if ActionAnimations.Checked[I] then Inc(COunt);
    if Count > 1 then
      Result := Format('%s, %d Animations assigned', [TreeView.Selected.Text, Count])
    else
      Result := Format('%s, %d Animation assigned', [TreeView.Selected.Text, Count]);
  end
  else if Actor.Animations.Count > 1 then
    Result := Format('%d Animations', [Actor.Animations.Count])
  else
    Result := Format('%d Animation', [Actor.Animations.Count])
end;

function TActorEditor.IsSaved: Boolean;
var
  DefActor, DefFile: String;
begin
  if Modified then
  begin
    if Actor.Name = EmptyStr then
      DefActor := 'Actor'
    else
      DefActor := Actor.Name;
    if FileName = EmptyStr then
      DefFile := DefActor
    else
      DefFile := FileName;
    case MessageDlg(Format(SFileModified, [DefActor, DefFile]), mtWarning, mbYesNoCancel, 0) of
      mrYes: FileSaveExecute(Self);
      mrNo: Modified := False;
    end;
  end;
  Result := not Modified;
end;

procedure TActorEditor.ResetControls;
begin
  ActIdx := -1; FrmIdx := -1; AnmIdx := -1;
  if PreviewForm.Visible then PreviewForm.Hide;
  TreeView.Selected := TreeView.Items[0];
  TreeView.TopItem := TreeView.Selected;
  TreeView.Items[0].Item[0].Collapse(True);
  TreeView.Items[0].Item[1].Collapse(True);
  ActiveControl := TreeView;
end;

procedure TActorEditor.EnableControls(Yes: Boolean);
var
  I: Integer;
  BackColor: TColor;
begin
  InternalChanging := True;
  if Yes then
    BackColor := clWindow
  else
    BackColor := clBtnFace;
  Notebook.Enabled := Yes;
  for I := 0 to DurationGroupBox.ControlCount-1 do
  begin
    DurationGroupBox.Controls[I].Enabled := Yes;
    if DurationGroupBox.Controls[I] is TRxSpinEdit then
      with DurationGroupBox.Controls[I] as TRxSpinEdit do
      begin
        Color := BackColor;
        if not Yes then Text := EmptyStr;
      end;
  end;
  for I := 0 to BranchGroupBox.ControlCount-1 do
  begin
    BranchGroupBox.Controls[I].Enabled := Yes;
    if BranchGroupBox.Controls[I] is TRxSpinEdit then
      with BranchGroupBox.Controls[I] as TRxSpinEdit do
      begin
        Color := BackColor;
        if not Yes then Text := EmptyStr;
      end;
  end;
  PRest.Text := EmptyStr;
  ExitBranched.Checked := False; 
  InternalChanging := False;
end;

procedure TActorEditor.ValidateActor;
var
  I: Integer;
  BadFrame: Integer;
  HasRestPose: Boolean;
begin
  if Length(Actor.Name) = 0 then
    raise Exception.Create(SNoActorName);
  if not IsValidIdent(Actor.Name) then
    raise Exception.Create(SActorNameError);
  HasRestPose := False;
  for I := 0 to Actor.Animations.Count-1 do
    with Actor.Animations[I] do
    begin
      if aaRestPose in Actions then
        HasRestPose := True;
      if Frames.Count = 0 then
      begin
        TreeView.Selected := AnimationsNode.Item[I];
        raise Exception.CreateFmt(SNoFrame, [Name]);
      end
      else if HasExitBranch then
      begin
        BadFrame := FindInvalidExitBranch;
        if BadFrame >= 0 then
        begin
          TreeView.Selected := AnimationsNode.Item[I].Item[BadFrame];
          raise Exception.CreateFmt(SBadExitBranch, [BadFrame+1, Name]);
        end;
      end
      else if ExitType = etExitBranch then
      begin
        TreeView.Selected := AnimationsNode.Item[I];
        raise Exception.CreateFmt(SNoExitBranch, [Name]);
      end;
    end;
  if not HasRestPose then
    raise Exception.Create(SNoRestPose);
end;

procedure TActorEditor.BuildActor(LibName: String);

  function CreateTempRes: String;
  begin
    Result := TempFileName('AAE-');
    SaveToFile(Result, True);
  end;

  function CreateProject(LibName, ResName: String): String;
  var
    I: Integer;
    F: TextFile;
    ResFileNameOnly: String;
    LibNameOnly, LibExtOnly: String;
  begin
    ResFileNameOnly := ExtractFileName(ResName);
    LibNameOnly := ChangeFileExt(ExtractFileName(LibName), '');
    LibExtOnly := ReplaceStr(ExtractFileExt(LibName), '.', '');
    Result := ChangeFileExt(LibName, '.dpr');
    AssignFile(F, Result);
    Rewrite(F);
    try
      for I := 0 to LibSource.Strings.Count-1 do
        if Pos('%f', LibSource.Strings[I]) <> 0 then
          WriteLn(F, ReplaceStr(LibSource.Strings[I], '%f', LibNameOnly))
        else if Pos('%r', LibSource.Strings[I]) <> 0 then
          WriteLn(F, ReplaceStr(LibSource.Strings[I], '%r', ResFileNameOnly))
        else if Pos('%e', LibSource.Strings[I]) <> 0 then
          WriteLn(F, ReplaceStr(LibSource.Strings[I], '%e', LibExtOnly))
        else
          WriteLn(F, LibSource.Strings[I]);
    finally
      CloseFile(F);
    end;
  end;

  function Execute(Command: String; ShowCmd: Word; Wait: Boolean): Boolean;
  var
    StartupInfo: TStartupInfo;
    ProcessInfo: TProcessInformation;
  begin
    FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
    FillChar(ProcessInfo, SizeOf(TProcessInformation), 0);
    with StartupInfo do
    begin
      cb := SizeOf(TStartupInfo);
      dwFlags := STARTF_USESHOWWINDOW;
      wShowWindow := ShowCmd;
    end;
    Result := CreateProcess(nil, PChar(Command), nil, nil, False,
                            CREATE_NEW_PROCESS_GROUP or NORMAL_PRIORITY_CLASS,
                            nil, nil, StartupInfo, ProcessInfo);
    if Result and Wait then
      WaitForSingleObject(ProcessInfo.hProcess, INFINITE);
  end;

  function CallDCC32(DCC32, LibName, PrjName, ResName: String): Boolean;
  var
    CommandLine: String;
    OldLibAge: Integer;
    OutputPath, ResourcePath: String;
  begin
    Result := False;
    OutputPath := ExcludeTrailingBackslash(ExtractFilePath(LibName));
    ResourcePath := ExcludeTrailingBackslash(ExtractFilePath(ResName));
    CommandLine := Format('"%s" -D- -Y- -I- -L- "%s" "-E%s" "-R%s"',
      [DCC32, PrjName, OutputPath, ResourcePath]);
    OldLibAge := FileAge(LibName);
    if Execute(CommandLine, SW_HIDE, True) then
    begin
      if OldLibAge >= FileAge(LibName) then
        MessageDlg(SBuildError, mtWarning, [mbOK], 0)
      else
        Result := True;
    end
    else
      MessageDlg(SDCC32Error, mtError, [mbOK], 0);
  end;

var
  PrjName, ResName: String;

begin
  if Modified then
    ResName := CreateTempRes
  else
    ResName := FileName;
  Screen.Cursor := crHourGlass;
  StatusBar.Panels[0].Text := 'Building ' + LibName;
  Update;
  try
    PrjName := CreateProject(LibName, ResName);
    CallDCC32(DCC32.Caption, LibName, PrjName, ResName);
  finally
    if FileExists(PrjName) then DeleteFile(PrjName);
    if ResName <> FileName then DeleteFile(ResName);
    StatusBar.Panels[0].Text := '';
    Screen.Cursor := crDefault;
  end;
end;

procedure TActorEditor.LoadFromFile(const aFileName: String);
var
  Handle: THandle;
begin
  if IsSaved then
  begin
    Screen.Cursor := crHourGlass;
    StatusBar.Panels[0].Text := 'Loading ' + aFileName;
    Update;
    try
      MRUManager.Remove(aFileName);
      if CompareText(ExtractFileExt(aFileName), '.aal') = 0 then
      begin
        Actor.LoadFromLibrary(aFileName);
        NoName := True;
      end
      else if CompareText(ExtractFileExt(aFileName), '.aad') = 0 then
      begin
        Actor.LoadFromFile(aFileName);
        NoName := False;
      end
      else
      begin
        Handle := LoadLibrary(PChar(aFileName));
        if Handle > 32 then
        begin
          FreeLibrary(Handle);
          Actor.LoadFromLibrary(aFileName);
          NoName := True;
        end
        else
        begin
          Actor.LoadFromFile(aFileName);
          NoName := False;
        end;
      end;
      ApplyActor;
      if FileName <> EmptyStr then
        MRUManager.Add(FileName, 0);
      Caption := Application.Title + ' - ' + aFileName;
      FileName := aFileName;
      Modified := False;
    finally
      StatusBar.Panels[0].Text := '';
      Screen.Cursor := crDefault;
    end;
  end;
end;

procedure TActorEditor.SaveToFile(const aFileName: String; Temporary: Boolean);
begin
  Screen.Cursor := crHourGlass;
  StatusBar.Panels[0].Text := 'Saving ' + aFileName;
  Update;
  try
    Actor.SaveToFile(aFileName);
    if not Temporary then
    begin
      Caption := Application.Title + ' - ' + aFileName;
      FileName := aFileName;
      Modified := False;
    end;
  finally
    StatusBar.Panels[0].Text := '';
    Screen.Cursor := crDefault;
  end;
end;

procedure TActorEditor.ScaleImageToBitmap(G: TGraphic);
var
  R: TRect;
begin
  R.Left := 0;
  R.Top := 0;
  if (Bitmap.Width >= G.Width) and (Bitmap.Height >= G.Height) then
  begin
    R.Right := G.Width;
    R.Bottom := G.Height;
  end
  else if (Bitmap.Width / G.Width) < (Bitmap.Height / G.Height) then
  begin
    R.Bottom := MulDiv(G.Height, Bitmap.Width, G.Width);
    R.Right := Bitmap.Width;
  end
  else
  begin
    R.Right := MulDiv(G.Width, Bitmap.Height, G.Height);
    R.Bottom := Bitmap.Height;
  end;
  OffsetRect(R, (Bitmap.Width - R.Right) div 2, (Bitmap.Height - R.Bottom) div 2);
  Bitmap.Canvas.Brush.Color := Transparent.Color;
  Bitmap.Canvas.FillRect(Bitmap.Canvas.ClipRect);
  Bitmap.Canvas.StretchDraw(R, G);
end;

procedure TActorEditor.ActorPaletteChanged;
begin
  if Actor.Palette <> 0 then
  begin
    if Transparent.Color <> clNone then
      Actor.BlindColorEntry := GetNearestPaletteIndex(Actor.Palette, Transparent.Color)
    else if Actor.BlindColorEntry > Actor.PaletteEntries.palNumEntries then
      Actor.BlindColorEntry := Actor.PaletteEntries.palNumEntries-1;
    with Actor.PaletteEntries.palPalEntry[Actor.BlindColorEntry] do
      Transparent.Color := TColor(RGB(peRed, peGreen, peBlue));
    Bitmap.Palette := CopyPalette(Actor.Palette);
  end
  else
  begin
    Bitmap.Palette := 0;
    Transparent.Color := clNone;
  end;
  PreviewForm.Palette := Actor.Palette;
  PreviewForm.TransparentColor := Transparent.Color;
  PostMessage(PreviewForm.Handle, WM_QUERYNEWPALETTE, 0, 0);
end;

procedure TActorEditor.NewActor(DefaultAnimations: Boolean);
var
  Action: TActorAction;
  Animation: TAnimationData;
begin
  Actor.Clear;
  if DefaultAnimations then
  begin
    for Action := Succ(Low(TActorAction)) to High(TActorAction) do
    begin
      Animation := TAnimationData.Create(Actor);
      Animation.Name := AnimationActions.Items[Ord(Action)-1];
      Include(Animation.Actions, Action);
      Actor.Animations.Add(Animation);
    end;
  end;
  ApplyActor;
  NoName := True;
  FileName := '';
  Caption := Application.Title;
  Modified := False;
end;

procedure TActorEditor.ApplyActor;
var
  Node: TTreeNode;
  I, J: Integer;
begin
  InternalChanging := True;
  Transparent.Color := clNone;
  ActorName.Text := Actor.Name;
  VerInfo.ItemIndex := Ord(viComments);
  VerValue.Text := Actor.VersionValues[viComments];
  Language.ItemIndex := LangIndex(Actor.Language);
  AnimWidth.AsInteger := Actor.Width;
  AnimHeight.AsInteger := Actor.Height;
  TreeView.Items.BeginUpdate;
  try
    AnimationsNode.DeleteChildren;
    for I := 0 to Actor.Animations.Count-1 do
    begin
      Node := TreeView.Items.AddChild(AnimationsNode, Actor.Animations[I].Name);
      Node.ImageIndex := 18;
      Node.SelectedIndex := 18;
      for J := 0 to Actor.Animations[I].Frames.Count-1 do
        with TreeView.Items.AddChild(Node, Format('Frame %d', [J + 1])) do
        begin
          ImageIndex := 19;
          SelectedIndex := 19;
        end;
    end;
  finally
    TreeView.Items.EndUpdate;
  end;
  PreviewForm.ClientWidth := Actor.Width;
  PreviewForm.ClientHeight := Actor.Height;
  Bitmap.Width := Actor.Width;
  Bitmap.Height := Actor.Height;
  ActorPaletteChanged;
  ResetControls;
  InternalChanging := False;
end;

procedure TActorEditor.ApplyAnimation(Index: Integer);
var
  I: Integer;
begin
  InternalChanging := True;
  AnmIdx := Index;
  for I := ReturnAnimation.Items.Count-1 downto 2 do
    ReturnAnimation.Items.Delete(I);
  for I := 0 to Actor.Animations.Count-1 do
    if I <> AnmIdx then
      ReturnAnimation.Items.Add(Actor.Animations[I].Name);
  with Actor.Animations[AnmIdx] do
  begin
    AnimationName.Text := Name;
    case ExitType of
      etNone: ReturnAnimation.ItemIndex := 0;
      etExitBranch: ReturnAnimation.ItemIndex := 1;
    else
      ReturnAnimation.ItemIndex := ReturnAnimation.Items.IndexOf(ReturnName);
    end;
    for I := 0 to AnimationActions.Items.Count-1 do
      AnimationActions.Checked[I] := (TActorAction(I+1) in Actions);
    if Frames.Count > 0 then
      PreviewForm.Display(Frames[0].Image, 'Frame 1 - ' + Name)
    else
      PreviewForm.Display(nil, 'No Frame - ' + Name);
  end;
  InternalChanging := False;
end;

procedure TActorEditor.ApplyFrame(AIndex, FIndex: Integer);
begin
  InternalChanging := True;
  AnmIdx := AIndex;
  FrmIdx := FIndex;
  with Actor.Animations[AnmIdx].Frames[FrmIdx] do
  begin
    if not Playing then
    begin
      P1.AsInteger := Branches[1].Precent;
      F1.Enabled := (Branches[1].Precent <> 0);
      F1.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
      if Branches[1].Precent > 0 then
        F1.AsInteger := Branches[1].Frame + 1
      else
        F1.Text := '';
      P2.AsInteger := Branches[2].Precent;
      F2.Enabled := (Branches[2].Precent <> 0);
      F2.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
      if Branches[2].Precent > 0 then
        F2.AsInteger := Branches[2].Frame + 1
      else
        F2.Text := '';
      P3.AsInteger := Branches[3].Precent;
      F3.Enabled := (Branches[3].Precent <> 0);
      F3.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
      if Branches[3].Precent > 0 then
        F3.AsInteger := Branches[3].Frame + 1
      else
        F3.Text := '';
      P4.AsInteger := Branches[4].Precent;
      F4.Enabled := (Branches[4].Precent <> 0);
      F4.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
      if Branches[4].Precent > 0 then
        F4.AsInteger := Branches[4].Frame + 1
      else
        F4.Text := '';
      PRest.Text := IntToStr(100 - (P1.AsInteger + P2.AsInteger + P3.AsInteger + P4.AsInteger));
      ExitBranched.Checked := ExitBranch.Enabled;
      ExitFrame.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
      if ExitBranch.Enabled then
        ExitFrame.AsInteger := ExitBranch.Frame + 1
      else
        ExitFrame.Text := '';
      ExitFrame.Enabled := ExitBranch.Enabled;
      Duration.AsInteger := Delay;
    end;
    PreviewForm.Display(Image, TreeView.Selected.Text + ' - ' + Actor.Animations[AnmIdx].Name);
  end;
  InternalChanging := False;
end;

procedure TActorEditor.ApplyAction(Index: Integer; Recreate: Boolean);
var
  I: Integer;
  Action: TActorAction;
begin
  InternalChanging := True;
  ActIdx := Index;
  Action := TActorAction(ActIdx+1);
  if Recreate then
  begin
    ActionAnimations.Items.BeginUpdate;
    try
      ActionAnimations.Items.Clear;
      for I := 0 to Actor.Animations.Count-1 do
      begin
        ActionAnimations.Items.Add(Actor.Animations[I].Name);
        ActionAnimations.Checked[I] := (Action in Actor.Animations[I].Actions);
      end;
    finally
      ActionAnimations.Items.EndUpdate;
    end;
  end
  else
    for I := 0 to Actor.Animations.Count-1 do
      ActionAnimations.Checked[I] := (Action in Actor.Animations[I].Actions);
  InternalChanging := False;
end;

procedure TActorEditor.AddAnimation(Animation: TAnimationData);
var
  Index: Integer;
  Node: TTreeNode;
begin
  if Animation.Name = '' then
    Animation.Name := Actor.Animations.UniqueName('Animation 1');
  Index := Actor.Animations.Add(Animation);
  Node := TreeView.Items.AddChild(AnimationsNode, Animation.Name);
  Node.MoveTo(AnimationsNode.Item[Index], naInsert);
  Node.ImageIndex := 18;
  Node.SelectedIndex := 18;
  for Index := 0 to Animation.Frames.Count-1 do
    with TreeView.Items.AddChild(Node, Format('Frame %d', [Index + 1])) do
    begin
      ImageIndex := 19;
      SelectedIndex := 19;
    end;
  TreeView.Selected := Node;
  Modified := True;
end;

procedure TActorEditor.AddFrame(Frame: TFrameData);
var
  Index: Integer;
  Node: TTreeNode;
begin
  if FrmIdx >= 0 then
    Index := FrmIdx + 1
  else
    Index := Actor.Animations[AnmIdx].Frames.Count;
  Actor.Animations[AnmIdx].Frames.Insert(Index, Frame);
  Node := TreeView.Items.AddChild(AnimationsNode.Item[AnmIdx],
          Format('Frame %d', [Actor.Animations[AnmIdx].Frames.Count]));
  Node.ImageIndex := 19;
  Node.SelectedIndex := 19;
  TreeView.Selected := AnimationsNode.Item[AnmIdx].Item[Index];
  Modified := True;
end;

procedure TActorEditor.LoadImage(ImageFileName: String; NewFrame: Boolean);
var
  P: TPicture;
  Frame: TFrameData;
  I: Integer;
begin
  P := TPicture.Create;
  try
    P.LoadFromFile(ImageFileName);
    if (P.Graphic is TGIFImage) or ((P.Graphic is TBitmap) and
       (P.Bitmap.PixelFormat = pf8bit)) then
    begin
      if Actor.Palette = 0 then
      begin
        Actor.Palette := CopyPalette(P.Graphic.Palette);
        if (P.Graphic is TGIFImage) and TGIFImage(P.Graphic).Transparent then
          Transparent.Color := TGIFImage(P.Graphic).TransparentColor;
        ActorPaletteChanged;
      end;
      if NewFrame then
      begin
        Frame := TFrameData.Create(Actor.Animations[AnmIdx]);
        Frame.Delay := DefaultDuration.AsInteger;
      end
      else
      begin
        Frame := Actor.Animations[AnmIdx].Frames[FrmIdx];
        Frame.Image.Clear;
      end;
      ScaleImageToBitmap(P.Graphic);
      Bitmap.SaveToStream(Frame.Image);
      if NewFrame then
        AddFrame(Frame)
      else
        PreviewForm.Display(Frame.Image, TreeView.Selected.Text + ' - ' + Actor.Animations[AnmIdx].Name);
      if (P.Graphic is TGIFImage) and (TGIFImage(P.Graphic).Count > 1) and
         (MessageDlg(Format(SMultiFrameFile, [ImageFIleName]), mtConfirmation,
         [mbYes, mbNo], 0) = mrYes) then
      begin
        for I := 1 to TGIFImage(P.Graphic).Count-1 do
        begin
          TGIFImage(P.Graphic).FrameIndex := I;
          Frame := TFrameData.Create(Actor.Animations[AnmIdx]);
          Frame.Delay := TGIFImage(P.Graphic).Frames[I].AnimateInterval div 10;
          ScaleImageToBitmap(P.Graphic);
          Bitmap.SaveToStream(Frame.Image);
          AddFrame(Frame);
          Inc(FrmIdx);
        end;
      end;
      Modified := True;
    end
    else
      raise Exception.CreateFmt(SColorError, [ImageFileName]);
  finally
    P.Free;
  end;
end;

procedure TActorEditor.PlayAnimation(UseExitBranch: Boolean);
begin
  if not Playing and (Actor.Animations[AnmIdx].Frames.Count > 0) then
  begin
    EnableControls(False);
    Playing := True;
    PlayingExitBranching := UseExitBranch;
    AnimationPreview.Assign(AnimationStop);
    AnimationPreview.OnExecute := AnimationStop.OnExecute;
    NextFrameTimer(Self);
  end;
end;

procedure TActorEditor.StopAnimation;
begin
  if Playing then
  begin
    RxTimerList.Active := False;
    AnimationPreview.Assign(AnimationPlay);
    AnimationPreview.OnExecute := AnimationPlay.OnExecute;
    Playing := False;
    EnableControls(True);
    ApplyFrame(AnmIdx, FrmIdx);
  end;
end;

procedure TActorEditor.FormCreate(Sender: TObject);
begin
  NoName := True;
  AnimationsNode := TreeView.Items[0].Item[0];
  Actor := TActorData.Create;
  Bitmap := TBitmap.Create;
  AuxBitmap := TBitmap.Create;
  AuxBitmap.TransparentMode := tmAuto;
  AuxBitmap.Transparent := True;
  Notebook.PageIndex := 0;
  TreeView.Items[0].Expand(False);
  DragAcceptFiles(Handle, True);
end;

procedure TActorEditor.FormActivate(Sender: TObject);
const
  FirstCall: Boolean = True;
begin
  if FirstCall then
  begin
    FirstCall := False;
    Update;
    try
      if ParamCount > 0 then
        LoadFromFile(ParamStr(1));
    finally
      ApplyActor;
    end;
  end;
end;

procedure TActorEditor.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  CanClose := IsSaved;
  if CanClose and (FileName <> '') then
    MRUManager.Add(FileName, 0);
end;

procedure TActorEditor.FormDestroy(Sender: TObject);
begin
  DragAcceptFiles(Handle, False);
  AuxBitmap.Free;
  Bitmap.Free;
  Actor.Free;
end;

procedure TActorEditor.ApplicationEventsHint(Sender: TObject);
begin
  StatusBar.Panels[0].Text := GetLongHint(Application.Hint);
end;

procedure TActorEditor.ApplicationEventsException(Sender: TObject;
  E: Exception);
begin
  MessageDlg(#10#13 + E.Message + '.'#10#13, mtWarning, [mbOK], 0);
end;

procedure TActorEditor.MRUManagerClick(Sender: TObject; const RecentName,
  Caption: String; UserData: Integer);
begin
  LoadFromFile(RecentName);
end;

procedure TActorEditor.StatusBarResize(Sender: TObject);
begin
  StatusBar.Panels[0].Width := StatusBar.ClientWidth - StatusBar.Panels[1].Width;
end;

procedure TActorEditor.TreeViewChange(Sender: TObject; Node: TTreeNode);
var
  OldPage: Integer;
  ShowPreview: Boolean;
  ActiveForm: TForm;
begin
  ActIdx := -1; FrmIdx := -1; AnmIdx := -1;
  OldPage := Notebook.PageIndex;
  // Select Notebook's active page
  case Node.Level of
    0: Notebook.ActivePage := 'Actor';
    1: case Node.Index of
         0: Notebook.ActivePage := 'Animations';
         1: Notebook.ActivePage := 'Actions';
       end;
    2: case Node.Parent.Index of
         0: Notebook.ActivePage := 'Animation';
         1: Notebook.ActivePage := 'Action';
       end;
    3: Notebook.ActivePage := 'Frame';
  end;
  // Set contents of Notebook's page
  case Notebook.PageIndex of
    2: begin
         ApplyAnimation(Node.Index);
         TreeView.PopupMenu := AnimationPopupMenu;
         ShowPreview := Node.HasChildren;
       end;
    3: begin
         ApplyFrame(Node.Parent.Index, Node.Index);
         TreeView.PopupMenu := FramePopupMenu;
         ShowPreview := True;
       end;
    5: begin
         ApplyAction(Node.Index, OldPage <> Notebook.PageIndex);
         TreeView.PopupMenu := nil;
         ShowPreview := False;
       end;
  else
    TreeView.PopupMenu := nil;
    ShowPreview := False;
  end;
  // Sets preview form visibility
  if ShowPreview then
  begin
    if not PreviewForm.Visible then
    begin
      ActiveForm := Screen.ActiveForm;
      PreviewForm.Show;
      SetActiveWindow(ActiveForm.Handle);
    end;
    PreviewForm.Update;
  end
  else if PreviewForm.Visible then
    PreviewForm.Hide;
end;

procedure TActorEditor.TreeViewMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ClickedItem := TreeView.GetNodeAt(X, Y);
end;

procedure TActorEditor.TreeViewDblClick(Sender: TObject);
begin
  if (ClickedItem <> nil) and (FrmIdx >= 0) then
    AnimationLoadImageExecute(Self);
end;

procedure TActorEditor.TreeViewStartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  if (TreeView.Selected = nil) or (TreeView.Selected.Level <> 3) then
  begin
    TreeView.EndDrag(False);
    Abort;
  end;
end;

procedure TActorEditor.TreeViewDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
var
  Node: TTreeNode;
begin
  Node := TreeView.GetNodeAt(X, Y);
  Accept := (Node <> nil) and (
    ((Node.Level = 3) and (Node.Parent.Index = AnmIdx)) or
    ((Node.Level = 2) and (Node.Parent.Index = 0) and (Node.Index = AnmIdx)));
end;

procedure TActorEditor.TreeViewDragDrop(Sender, Source: TObject; X,
  Y: Integer);
var
  Node: TTreeNode;
  NewFrmIdx: Integer;
begin
  Node := TreeView.GetNodeAt(X, Y);
  if Node <> nil then
  begin
    NewFrmIdx := FrmIdx;
    if (Node.Level = 3) and (Node.Parent.Index = AnmIdx) then
      NewFrmIdx := Node.Index
    else if (Node.Level = 2) and (Node.Parent.Index = 0) and (Node.Index = AnmIdx) then
      NewFrmIdx := 0;
    if FrmIdx <> NewFrmIdx then
    begin
      Actor.Animations[AnmIdx].Frames.Move(FrmIdx, NewFrmIdx);
      TreeView.Selected := nil;
      TreeView.Selected := Node;
      Modified := True;
    end;
  end;
end;

procedure TActorEditor.NextFrameTimer(Sender: TObject);
var
  NewFrame: Integer;
  Node: TTreeNode;
  StartTime, ElapsedTime: Cardinal;
begin
  RxTimerList.Active := False;
  if FrmIdx < 0 then FrmIdx := 0;
  StartTime := GetTickCount;
  if (Sender <> Self) or PlayingExitBranching then
    NewFrame := Actor.Animations[AnmIdx].FindNextFrame(FrmIdx, not PlayingExitBranching)
  else
    NewFrame := FrmIdx;
  if NewFrame >= 0 then
  begin
    Node := AnimationsNode.Item[AnmIdx].Item[NewFrame];
    if (Node.AbsoluteIndex < TreeView.TopItem.AbsoluteIndex) or
       (Node.AbsoluteIndex - TreeView.TopItem.AbsoluteIndex > 17) then
    begin
      if NewFrame > FrmIdx then
        TreeView.TopItem := Node
      else if NewFrame > 17 then
        TreeView.TopItem := AnimationsNode.Item[AnmIdx].Item[NewFrame - 17]
      else
        TreeView.TopItem := AnimationsNode.Item[AnmIdx].Item[0];
    end;
    TreeView.Selected := Node;
    with Actor.Animations[AnmIdx].Frames[NewFrame] do
    begin
      if Sound.Size > 0 then
        PlaySound(Sound.Memory, 0, SND_MEMORY or SND_NOWAIT or SND_ASYNC or SND_NODEFAULT);
      ElapsedTime := GetTickCount - StartTime;
      NextFrame.Interval := (Delay * 10) - ElapsedTime;
      if NextFrame.Interval <= 0 then NextFrame.Interval := 1;
    end;
    NextFrame.Enabled := True;
    RxTimerList.Active := True;
  end
  else
    StopAnimation;
end;

procedure TActorEditor.ActorNameChange(Sender: TObject);
begin
  if not InternalChanging then
  begin
    if Actor.Name <> ActorName.Text then
    begin
      Actor.Name := ActorName.Text;
      Modified := True;
    end;
  end;
end;

procedure TActorEditor.ActorNameExit(Sender: TObject);
begin
  if not IsValidIdent(ActorName.Text) then
  begin
    TreeView.Selected := TreeView.Items[0];
    ActorName.SetFocus;
    raise Exception.Create(SActorNameError);
  end;
end;

procedure TActorEditor.ActorNameKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['A'..'Z', 'a'..'z', '0'..'9', #8, ^C, ^V, ^X]) then Key := #0;
end;

procedure TActorEditor.LanguageChange(Sender: TObject);
begin
  if not InternalChanging then
    if Actor.Language <> LanguageIDs[Language.ItemIndex] then
    begin
      Actor.Language := LanguageIDs[Language.ItemIndex];
      Modified := True;
    end;
end;

procedure TActorEditor.VerInfoChange(Sender: TObject);
begin
  if not InternalChanging then
    VerValue.Text := Actor.VersionValues[TVerInfoItem(VerInfo.ItemIndex)];
end;

procedure TActorEditor.VerValueChange(Sender: TObject);
begin
  if not InternalChanging then
    if Actor.VersionValues[TVerInfoItem(VerInfo.ItemIndex)] <> VerValue.Text then
    begin
      Actor.VersionValues[TVerInfoItem(VerInfo.ItemIndex)] := DelSpace1(DelRSpace(VerValue.Text));
      Modified := True;
    end;
end;

procedure TActorEditor.AnimWidthChange(Sender: TObject);
begin
  if not InternalChanging then
    if Actor.Width <> AnimWidth.AsInteger then
    begin
      Actor.Width := AnimWidth.AsInteger;
      PreviewForm.ClientWidth := Actor.Width;
      Bitmap.Width := Actor.Width;
      Modified := True;
    end;
end;

procedure TActorEditor.AnimHeightChange(Sender: TObject);
begin
  if not InternalChanging then
    if Actor.Height <> AnimHeight.AsInteger then
    begin
      Actor.Height := AnimHeight.AsInteger;
      PreviewForm.ClientHeight := Actor.Height;
      Bitmap.Height := Actor.Height;
      Modified := True;
    end;
end;

procedure TActorEditor.LoadPaletteClick(Sender: TObject);
var
  P: TPicture;
begin
  OpenPictureDialog.FileName := EmptyStr;
  if OpenPictureDialog.Execute then
  begin
    OpenPictureDialog.InitialDir := ExtractFilePath(OpenPictureDialog.FileName);
    P := TPicture.Create;
    try
      P.LoadFromFile(OpenPictureDialog.FileName);
      if (P.Graphic is TGIFImage) or ((P.Graphic is TBitmap) and
         (P.Bitmap.PixelFormat = pf8bit)) then
      begin
        Actor.Palette := CopyPalette(P.Graphic.Palette);
        ActorPaletteChanged;
        Modified := True;
      end
      else
        raise Exception.CreateFmt(SColorError, [OpenPictureDialog.FileName]);
    finally
      P.Free;
    end;
  end;
end;

procedure ProcessFrames(const Index: Integer; var OK: Boolean; var TheBitmap: TBitmap);
var
  I, A, F: Integer;
begin
  TheBitmap := nil;
  with ActorEditor do
  begin
    I := 0;
    for A := 0 to Actor.Animations.Count-1 do
      for F := 0 to Actor.Animations[A].Frames.Count-1 do
      begin
        Inc(I);
        if I = Index then
        begin
          OK := True;
          with Actor.Animations[A].Frames[F] do
          begin
            Image.Position := 0;
            AuxBitmap.LoadFromStream(Image);
            ScaleImageToBitmap(AuxBitmap);
            TheBitmap := Bitmap;
          end;
          Exit;
        end;
      end;
    if Index = 1 then Abort;
  end;
end;

procedure TActorEditor.OptimizePaletteClick(Sender: TObject);
var
  A, F: Integer;
begin
  Screen.Cursor := crHourGlass;
  StatusBar.Panels[0].Text := 'Optimizing colors...';
  Update;
  try
    Bitmap.PixelFormat := pf24bit;
    Bitmap.Palette := 0;
    try
      Actor.Palette := CreateOptimizedPaletteForManyBitmaps(ProcessFrames, 7);
    except
      ActorPaletteChanged;
      raise;
    end;
    for A := 0 to Actor.Animations.Count-1 do
      for F := 0 to Actor.Animations[A].Frames.Count-1 do
        with Actor.Animations[A].Frames[F] do
        begin
          Image.Position := 0;
          AuxBitmap.LoadFromStream(Image);
          AuxBitmap.PixelFormat := pf24bit;
          ScaleImageToBitmap(AuxBitmap);
        end;
    Modified := True;
  finally
    StatusBar.Panels[0].Text := '';
    Screen.Cursor := crDefault;
  end;
end;

procedure TActorEditor.ChangeTransparentClick(Sender: TObject);
var
  NewColorIndex: Byte;
begin
  Transparent.Color := SelectColor(Actor.Palette, Transparent.Color);
  NewColorIndex := GetNearestPaletteIndex(Actor.Palette, Transparent.Color);
  if NewColorIndex <> Actor.BlindColorEntry then
  begin
    Actor.BlindColorEntry := NewColorIndex;
    PreviewForm.TransparentColor := Transparent.Color;
    Modified := True;
  end;
end;

procedure TActorEditor.AnimationNameExit(Sender: TObject);
var
  I, NewIndex: Integer;
  DupName: String;
begin
  AnimationName.Text := DelSpace1(DelRSpace(AnimationName.Text));
  if Actor.Animations[AnmIdx].Name <> AnimationName.Text then
  begin
    if AnimationName.Text = '' then
    begin
      AnimationName.SetFocus;
      AnimationName.Text := Actor.Animations[AnmIdx].Name;
      raise Exception.Create(SAnimNameError);
    end
    else if Actor.Animations.FindIndex(AnimationName.Text, AnmIdx) >= 0 then
    begin
      AnimationName.SetFocus;
      DupName := AnimationName.Text;
      AnimationName.Text := Actor.Animations[AnmIdx].Name;
      raise Exception.CreateFmt(SAnimNameDupError, [DupName]);
    end
    else
    begin
      // Updates return animations' name
      for I := 0 to Actor.Animations.Count-1 do
        if Actor.Animations[I].ReturnName = Actor.Animations[AnmIdx].Name then
          Actor.Animations[I].ReturnName := AnimationName.Text;
      // Updates animation's name
      Actor.Animations[AnmIdx].Name := AnimationName.Text;
      AnimationsNode.Item[AnmIdx].Text := AnimationName.Text;
      // Sorts animation list
//      IsSelected := AnimationsNode.Item[AnmIdx].Selected;
      NewIndex := Actor.Animations.Reindex(AnmIdx);
      if AnmIdx <> NewIndex then
      begin
        if NewIndex = AnimationsNode.Count-1 then
          AnimationsNode.Item[AnmIdx].MoveTo(AnimationsNode, naAddChild)
        else if NewIndex = 0 then
          AnimationsNode.Item[AnmIdx].MoveTo(AnimationsNode, naAddChildFirst)
        else if NewIndex > AnmIdx then
          AnimationsNode.Item[AnmIdx].MoveTo(AnimationsNode.Item[NewIndex+1], naInsert)
        else if NewIndex < AnmIdx then
          AnimationsNode.Item[AnmIdx].MoveTo(AnimationsNode.Item[NewIndex], naInsert);
        AnmIdx := NewIndex;
        TreeView.Selected := AnimationsNode.Item[AnmIdx];
      end;
      Modified := True;
    end;
  end;
end;

procedure TActorEditor.ReturnAnimationChange(Sender: TObject);
var
  NewExitType: TExitType;
begin
  if not InternalChanging then
  begin
    case ReturnAnimation.ItemIndex of
      0: NewExitType := etNone;
      1: NewExitType := etExitBranch;
    else
      NewExitType := etAnimation;
    end;
    with Actor.Animations[AnmIdx] do
    begin
      if ExitType <> NewExitType then
      begin
        ExitType := NewExitType;
        if NewExitType = etAnimation then
          ReturnName := ReturnAnimation.Text
        else
          ReturnName := '';
        Modified := True;
      end
      else if (NewExitType = etAnimation) and (ReturnName <> ReturnAnimation.Text) then
      begin
        ReturnName := ReturnAnimation.Text;
        Modified := True;
      end;
    end;
  end;
end;

procedure TActorEditor.AnimationActionsClickCheck(Sender: TObject);
var
  Action: TActorAction;
begin
  if not InternalChanging then
  begin
    Action := TActorAction(AnimationActions.ItemIndex+1);
    if AnimationActions.Checked[AnimationActions.ItemIndex] then
      Include(Actor.Animations[AnmIdx].Actions, Action)
    else
      Exclude(Actor.Animations[AnmIdx].Actions, Action);
    Modified := True;
  end;
end;

procedure TActorEditor.DurationChange(Sender: TObject);
begin
  if not InternalChanging then
    with Actor.Animations[AnmIdx].Frames[FrmIdx] do
    begin
      if Delay <> Duration.AsInteger then
      begin
        Delay := Duration.AsInteger;
        Modified := True;
      end;
    end;
end;

procedure TActorEditor.PrecentChange(Sender: TObject);
const
  Changing: Boolean = False;
var
  I, N, D, Rest: Integer;
  P: TRxSpinEdit;
begin
  if not InternalChanging then
    with Actor.Animations[AnmIdx].Frames[FrmIdx] do
    begin
      P := TRxSpinEdit(Sender);
      if not Changing and (Branches[P.Tag].Precent <> P.AsInteger) and
        (P.AsInteger in [0..100]) then
      begin
        Changing := True;
        Branches[P.Tag].Precent := P.AsInteger;
        // Calculates Non-Branch's precent
        Rest := 100;
        N := 0;
        for I := 1 to 4 do
          if Branches[I].Precent <> 0 then
          begin
            Dec(Rest, Branches[I].Precent);
            Inc(N);
          end;
        // Non-Branch's precent less than zero
        if Rest < 0 then
        begin
          Dec(N);
          repeat
            D := -Rest div N;
            if D = 0 then D := 1;
            for I := 1 to 4 do
            begin
              if (I <> P.Tag) and (Branches[I].Precent > 0) then
              begin
                if D <= Branches[I].Precent then
                begin
                  Inc(Rest, D);
                  Dec(Branches[I].Precent, D);
                end
                else
                begin
                  Inc(Rest, Branches[I].Precent);
                  Branches[I].Precent := 0;
                  Dec(N);
                end;
              end;
              if Rest >= 0 then Break;
            end;
          until Rest >= 0;
        end;
        // Updates branches with calculated values
        P1.AsInteger := Branches[1].Precent;
        F1.Enabled := (P1.AsInteger <> 0);
        F1.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
        if P1.AsInteger > 0 then
          F1.AsInteger := Branches[1].Frame + 1
        else
          F1.Text := '';
        P2.AsInteger := Branches[2].Precent;
        F2.Enabled := (P2.AsInteger <> 0);
        F2.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
        if P2.AsInteger > 0 then
          F2.AsInteger := Branches[2].Frame + 1
        else
          F2.Text := '';
        P3.AsInteger := Branches[3].Precent;
        F3.Enabled := (P3.AsInteger <> 0);
        F3.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
        if P3.AsInteger > 0 then
          F3.AsInteger := Branches[3].Frame + 1
        else
          F3.Text := '';
        P4.AsInteger := Branches[4].Precent;
        F4.Enabled := (P4.AsInteger <> 0);
        F4.MaxValue := Actor.Animations[AnmIdx].Frames.Count;
        if P4.AsInteger > 0 then
          F4.AsInteger := Branches[4].Frame + 1
        else
          F4.Text := '';
        PRest.Text := IntToStr(Rest);
        Modified := True;
        Changing := False;
      end;
    end;
end;

procedure TActorEditor.FrameBranchChange(Sender: TObject);
var
  F: TRxSpinEdit;
begin
  if not InternalChanging then
    with Actor.Animations[AnmIdx].Frames[FrmIdx] do
    begin
      F := TRxSpinEdit(Sender);
      if (Branches[F.Tag].Precent > 0) and (Branches[F.Tag].Frame <> F.AsInteger-1) then
      begin
        Branches[F.Tag].Frame := F.AsInteger-1;
        Modified := True;
      end;
    end;
end;

procedure TActorEditor.ExitBranchedClick(Sender: TObject);
begin
  if not InternalChanging then
    with Actor.Animations[AnmIdx].Frames[FrmIdx] do
    begin
      ExitBranch.Enabled := ExitBranched.Checked;
      if ExitBranched.Checked then
        ExitFrame.AsInteger := ExitBranch.Frame + 1
      else
        ExitFrame.Text := '';
      ExitFrame.Enabled := ExitBranched.Checked;
      Modified := True;
    end;
end;

procedure TActorEditor.ExitFrameChange(Sender: TObject);
begin
  if not InternalChanging then
    with Actor.Animations[AnmIdx].Frames[FrmIdx] do
    begin
      if ExitBranch.Enabled and (ExitBranch.Frame <> ExitFrame.AsInteger-1) then
      begin
        ExitBranch.Frame := ExitFrame.AsInteger-1;
        Modified := True;
      end;
    end;
end;

procedure TActorEditor.ActionAnimationsClickCheck(Sender: TObject);
var
  Action: TActorAction;
begin
  if not InternalChanging then
  begin
    Action := TActorAction(ActIdx+1);
    with Actor.Animations[ActionAnimations.ItemIndex] do
      if ActionAnimations.Checked[ActionAnimations.ItemIndex] then
        Include(Actions, Action)
      else
        Exclude(Actions, Action);
    Modified := True;
  end;
end;

procedure TActorEditor.ActionListUpdate(Action: TBasicAction;
  var Handled: Boolean);
begin
  Handled := True;
  if Modified then
    StatusBar.Panels[1].Text := 'Modified'
  else
    StatusBar.Panels[1].Text := '';
  OptimizePalette.Enabled := (Actor.Palette <> 0) and (Actor.Animations.Count > 0);
  ChangeTransparent.Enabled := (Actor.Palette <> 0);
  Reopen.Enabled := not Playing and (MRUManager.Strings.Count > 0);
  FileNew.Enabled := not Playing;
  FileOpen.Enabled := not Playing;
  FileSave.Enabled := not Playing;
  FileSaveAs.Enabled := not Playing;
  FileBuild.Enabled := not Playing and (Actor.Animations.Count > 0);
  EditCut.Enabled := not Playing and ((ActiveControl = TreeView) and (AnmIdx >= 0)) or
    ((ActiveControl is TCustomEdit) and (TCustomEdit(ActiveControl).SelLength > 0));
  EditCopy.Enabled := EditCut.Enabled;
  EditDelete.Enabled := EditCut.Enabled;
  EditPaste.Enabled := not Playing and (((ActiveControl = TreeView) and (((AnmIdx >= 0) and
    (Clipboard.HasFormat(CF_ANIMATION) or Clipboard.HasFormat(CF_FRAME))) or
    ((TreeView.Selected = AnimationsNode) and Clipboard.HasFormat(CF_ANIMATION))) or
    ((ActiveControl is TCustomEdit) and Clipboard.HasFormat(CF_TEXT))));
  AnimationNew.Enabled := not Playing;
  AnimationNewFrame.Enabled := not Playing and (AnmIdx >= 0);
  AnimationNewFrameFromImages.Enabled := not Playing and (AnmIdx >= 0);
  AnimationLoadImage.Enabled := not Playing and (FrmIdx >= 0);
  AnimationSaveImage.Enabled := not Playing and (FrmIdx >= 0) and
    (Actor.Animations[AnmIdx].Frames[FrmIdx].Image.Size > 0);
  AnimationLoadSound.Enabled := not Playing and (FrmIdx >= 0);
  AnimationSaveSound.Enabled := not Playing and (FrmIdx >= 0) and
    (Actor.Animations[AnmIdx].Frames[FrmIdx].Sound.Size > 0);
  AnimationRemoveSound.Enabled := AnimationSaveSound.Enabled;
  AnimationPlay.Enabled := (AnmIdx >= 0) and
    (Actor.Animations[AnmIdx].Frames.Count > 0);
  AnimationPreviewBranch.Enabled := not Playing and AnimationPlay.Enabled and
    Actor.Animations[AnmIdx].HasExitBranch;
  AnimationPreview.Enabled := (AnmIdx >= 0) and
    (Actor.Animations[AnmIdx].Frames.Count > 0);
  if Application.Hint = '' then
    StatusBar.Panels[0].Text := StatusText;
end;

procedure TActorEditor.ActionListExecute(Action: TBasicAction;
  var Handled: Boolean);
begin
  Handled := False;
  if ActiveControl = AnimationName then
    Toolbar.SetFocus;
end;

procedure TActorEditor.FileNewExecute(Sender: TObject);
var
  DefaultAnimations: Boolean;
begin
  if IsSaved then
  begin
    if not NoName and (FileName <> EmptyStr) then
      MRUManager.Add(FileName, 0);
    DefaultAnimations := (GetAsyncKeyState(VK_SHIFT) < 0);
    NewActor(DefaultAnimations);
  end;
end;

procedure TActorEditor.FileOpenExecute(Sender: TObject);
begin
  if OpenDialog.Execute then
  begin
    OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
    LoadFromFile(OpenDialog.FileName);
  end;
end;

procedure TActorEditor.FileSaveExecute(Sender: TObject);
begin
  if NoName or (FileName = EmptyStr) then
    FileSaveAsExecute(Self)
  else
    SaveToFile(FileName);
end;

procedure TActorEditor.FileSaveAsExecute(Sender: TObject);
begin
  if FileName = EmptyStr then
    SaveDialog.FileName := Actor.Name
  else if NoName then
    SaveDialog.FileName := ChangeFileExt(FileName, '.aad')
  else
    SaveDialog.FileName := FileName;
  if SaveDialog.Execute then
  begin
    SaveDialog.InitialDir := ExtractFilePath(SaveDialog.FileName);
    FileName := SaveDialog.FileName;
    NoName := False;
    FileSaveExecute(Self);
  end;
end;

procedure TActorEditor.FileBuildExecute(Sender: TObject);
begin
  ValidateActor;
  BuildDialog.FileName := Actor.Name;
  if BuildDialog.Execute then
  begin
    BuildDialog.InitialDir := ExtractFilePath(BuildDialog.FileName);
    BuildActor(BuildDialog.FileName);
  end;
end;

procedure TActorEditor.FileExitExecute(Sender: TObject);
begin
  if Playing then StopAnimation;
  Close;
end;

procedure TActorEditor.EditCutExecute(Sender: TObject);
begin
  EditCopyExecute(Self);
  EditDeleteExecute(Self);
end;

procedure TActorEditor.EditCopyExecute(Sender: TObject);
begin
  if ActiveControl = TreeView then
  begin
    if FrmIdx >= 0 then
      Actor.Animations[AnmIdx].Frames[FrmIdx].CopyToClipboard
    else if AnmIdx >= 0 then
     Actor.Animations[AnmIdx].CopyToClipboard;
  end
  else if ActiveControl is TCustomEdit then
    TCustomEdit(ActiveControl).CopyToClipboard;
end;

procedure TActorEditor.EditPasteExecute(Sender: TObject);
var
  Animation: TAnimationData;
  Frame: TFrameData;
begin
  if ActiveControl = TreeView then
  begin
    if (AnmIdx >= 0) and Clipboard.HasFormat(CF_FRAME) then
    begin
      Frame := TFrameData.Create(Actor.Animations[AnmIdx]);
      Frame.PasteFromClipboard;
      AddFrame(Frame);
    end
    else if ((AnmIdx >= 0) or (TreeView.Selected = AnimationsNode)) and
      Clipboard.HasFormat(CF_ANIMATION) then
    begin
      Animation := TAnimationData.Create(Actor);
      Animation.PasteFromClipboard;
      AddAnimation(Animation);
    end;
  end
  else if ActiveControl is TCustomEdit then
    TCustomEdit(ActiveControl).PasteFromClipboard;
end;

procedure TActorEditor.EditDeleteExecute(Sender: TObject);
begin
  if ActiveControl = TreeView then
  begin
    if FrmIdx >= 0 then
    begin
      Actor.Animations[AnmIdx].Frames.Delete(FrmIdx);
      AnimationsNode.Item[AnmIdx].GetLastChild.Delete;
      if Actor.Animations[AnmIdx].Frames.Count = 0 then
      begin
        TreeView.Selected := AnimationsNode.Item[AnmIdx];
        FrmIdx := -1;
      end
      else
      begin
        if Actor.Animations[AnmIdx].Frames.Count = FrmIdx then
          Dec(FrmIdx)
        else
          TreeView.Selected := nil;
        TreeView.Selected := AnimationsNode.Item[AnmIdx].Item[FrmIdx];
      end;
      Modified := True;
    end
    else if AnmIdx >= 0 then
    begin
      Actor.Animations.Delete(AnmIdx);
      AnimationsNode.Item[AnmIdx].Delete;
      if Actor.Animations.Count = 0 then
      begin
        TreeView.Selected := AnimationsNode;
        AnmIdx := -1;
      end
      else
      begin
        if Actor.Animations.Count = AnmIdx then
          Dec(AnmIdx);
        TreeView.Selected := AnimationsNode.Item[AnmIdx];
      end;
      Modified := True;
    end;
  end
  else if ActiveControl is TCustomEdit then
    TCustomEdit(ActiveControl).SelText := '';
end;

procedure TActorEditor.AnimationNewExecute(Sender: TObject);
begin
  AddAnimation(TAnimationData.Create(Actor));
end;

procedure TActorEditor.AnimationNewFrameExecute(Sender: TObject);
var
  Frame: TFrameData;
begin
  Frame := TFrameData.Create(Actor.Animations[AnmIdx]);
  Frame.Delay := DefaultDuration.AsInteger;
  AddFrame(Frame);
end;

procedure TActorEditor.AnimationNewFrameFromImagesExecute(Sender: TObject);
var
  I: Integer;
begin
  OpenPictureDialog.Options := OpenPictureDialog.Options + [ofAllowMultiSelect];
  try
    OpenPictureDialog.FileName := EmptyStr;
    if OpenPictureDialog.Execute then
    begin
      OpenPictureDialog.InitialDir := ExtractFilePath(OpenPictureDialog.FileName);
      for I := 0 to OpenPictureDialog.Files.Count-1 do
        LoadImage(OpenPictureDialog.Files[I], True);
    end;
  finally
    OpenPictureDialog.Options := OpenPictureDialog.Options - [ofAllowMultiSelect];
  end;
end;

procedure TActorEditor.AnimationPlayExecute(Sender: TObject);
begin
  PlayAnimation(False);
end;

procedure TActorEditor.AnimationPreviewBranchExecute(Sender: TObject);
var
  BadFrame: Integer;
begin
  BadFrame := Actor.Animations[AnmIdx].FindInvalidExitBranch;
  if BadFrame < 0 then
    PlayAnimation(True)
  else
  begin
    TreeView.Selected := AnimationsNode.Item[AnmIdx].Item[BadFrame];
    if ExitBranched.Checked then
      ActiveControl := ExitFrame
    else
      ActiveControl := ExitBranched;
    raise Exception.CreateFmt(SExitBranchError, [BadFrame+1]);
  end;
end;

procedure TActorEditor.AnimationStopExecute(Sender: TObject);
begin
  StopAnimation;
end;

procedure TActorEditor.AnimationLoadImageExecute(Sender: TObject);
begin
  OpenPictureDialog.FileName := EmptyStr;
  if OpenPictureDialog.Execute then
  begin
    OpenPictureDialog.InitialDir := ExtractFilePath(OpenPictureDialog.FileName);
    LoadImage(OpenPictureDialog.FileName, False);
  end;
end;

procedure TActorEditor.AnimationSaveImageExecute(Sender: TObject);
begin
  SavePictureDialog.FileName := Format('%s#%d', [Actor.Animations[AnmIdx].Name, FrmIdx+1]);
  if SavePictureDialog.Execute then
  begin
    SavePictureDialog.InitialDir := ExtractFilePath(SavePictureDialog.FileName);
    Actor.Animations[AnmIdx].Frames[FrmIdx].Image.SaveToFile(SavePictureDialog.FileName);
  end;
end;

procedure TActorEditor.AnimationLoadSoundExecute(Sender: TObject);
begin
  if OpenSoundDialog.Execute then
  begin
    OpenSoundDialog.InitialDir := ExtractFilePath(OpenSoundDialog.FileName);
    Actor.Animations[AnmIdx].Frames[FrmIdx].Sound.LoadFromFile(OpenSoundDialog.FileName);
    Modified := True;
  end;
end;

procedure TActorEditor.AnimationSaveSoundExecute(Sender: TObject);
begin
  SaveSoundDialog.FileName := Format('%s#%d', [Actor.Animations[AnmIdx].Name, FrmIdx+1]);
  if SaveSoundDialog.Execute then
  begin
    SaveSoundDialog.InitialDir := ExtractFilePath(SaveSoundDialog.FileName);
    Actor.Animations[AnmIdx].Frames[FrmIdx].Sound.SaveToFile(SaveSoundDialog.FileName);
  end;
end;

procedure TActorEditor.AnimationRemoveSoundExecute(Sender: TObject);
begin
  Actor.Animations[AnmIdx].Frames[FrmIdx].Sound.Clear;
  Modified := True;
end;

procedure TActorEditor.HelpAboutExecute(Sender: TObject);
begin
  TAboutBox.Execute;
end;

procedure TActorEditor.SplitterCanResize(Sender: TObject;
  var NewSize: Integer; var Accept: Boolean);
begin
  Accept := (NewSize >= Splitter.MinSize) and
    ((ClientWidth - Splitter.Width - NewSize) >= DetailsPanel.Constraints.MinWidth);
end;

end.

